# Guide du Débogueur Python : Terminal et PyCharm

## Utilisation du Débogueur dans le Terminal

### Lancement du Débogueur

Pour lancer le débogueur dans le terminal :
```
python -m pdb votre_script.py
```

Ou insérez `breakpoint()` dans votre code (Python 3.7+).

### Commandes Principales du Débogueur

- `n` (next) : Passer à la ligne suivante
- `s` (step) : Entrer dans une fonction
- `c` (continue) : Continuer jusqu'au prochain point d'arrêt
- `p variable` : Afficher la valeur d'une variable
- `display variable` : Afficher automatiquement une variable à chaque étape
- `undisplay variable` : Arrêter l'affichage automatique d'une variable
- `l` (list) : Afficher le code autour de la ligne actuelle
- `q` (quit) : Quitter le débogueur

### Évaluation de Variables et Expressions

Vous pouvez évaluer des expressions directement dans le débogueur :
```
p len(ma_liste)
p variable1 + variable2
p "La valeur est : " + str(ma_variable)
```

## Utilisation du Débogueur dans PyCharm

1. **Définir des points d'arrêt (breakpoints)** : Cliquez dans la marge gauche de l'éditeur.

2. **Lancer le débogueur** : Cliquez sur l'icône d'insecte vert ou utilisez `Maj+F9`.

3. **Contrôles de Débogage** :
   - Pas à pas détaillé (Step into) : `F7`
   - Pas à pas principal (Step over) : `F8`
   - Reprendre l'exécution : `F9`

4. **Fenêtre "Variables"** : Affiche toutes les variables dans la portée actuelle.

5. **Fenêtre "Montres" (Watches)** : Bouton droit sur la variable que vous voulez analyser dans la fenetre des variables
   - Ajoutez des expressions à surveiller
   - Évaluez des expressions complexes
   - Mettez à jour automatiquement à chaque pas

