import logging

# Chemin du fichier où les logs seront enregistrés
log_file = 'log/log_fibo.log'

# Définir le mode : 'w' pour write, 'a' pour append
file_mode = 'w'  # On écrase le log à chaque lancement


# Configuration du logging pour sauvegarder les logs dans un fichier
logging.basicConfig(
    level=logging.INFO,  # Niveau de log : DEBUG, INFO, WARNING, ERROR, CRITICAL
    format='%(asctime)s - %(levelname)s - %(message)s',  # Format du log : inclut l'heure, le niveau, et le message
    datefmt='%Y-%m-%d %H:%M:%S',  # Format de la date et de l'heure
    filename=log_file,  # Spécifie le fichier de log
    filemode=file_mode  # Définit le mode d'ouverture du fichier : 'w' pour remplacer, 'a' pour ajouter
)
from functools import lru_cache
@lru_cache()
def fibonacci(number:int) -> int:
    if not isinstance(number, int) or number < 0:
        logging.error("The function takes a positive integer as argument.")
        raise ValueError("Argument must be a positive int")
    if number == 0:
        return 1
    elif number == 1:
        return 1
    else:
        total = fibonacci(number-1) + fibonacci(number-2)

        logging.info(f"\nWe compute fibonacci pour n= {number}:\n "
                     f"Pour (n-1) = {number-1}: Fibo= {fibonacci(number-1)}\n "
                     f"Pour (n-2) = {number-2}: Fibo = {fibonacci(number-2)} \n "
                     f"Donc fibonacci(n) = {fibonacci(number-1)} + {fibonacci(number-2)} = {fibonacci(number-1) + fibonacci(number-2)}\n")
        return total

#fibonacci(-1)
fibonacci(5)