import logging

# Configure logging to include the time
logging.basicConfig(
    level=logging.DEBUG,  # Set the log level
    format='%(asctime)s - %(levelname)s - %(message)s',  # Include time in the log format
    datefmt='%Y-%m-%d %H:%M:%S'  # Optional: customize the time format
)

# Example log messages
logging.debug('This is a debug message.')
logging.info('This is an info message.')
logging.warning('This is a warning message.')
logging.error('This is an error message.')
logging.critical('This is a critical message.')

try:
    # Some code that might raise an exception
    x = 1 / 0
except Exception as e:
    logging.error("An error occurred: %s", e, exc_info=True)

try:
    1 / 0  # Some code that raises an exception
except ZeroDivisionError:
    logging.exception("A division by zero error occurred")
